// anand.ch

*******************************************************************************
* Pseudo functions to check data types
*******************************************************************************

#translate ISARRAY(<v>)      =>  ( VALTYPE(<v>)=="A" )
#translate ISBLOCK(<v>)      =>  ( VALTYPE(<v>)=="B" )
#translate ISCHARACTER(<v>)  =>  ( VALTYPE(<v>)=="C" )
#translate ISDATE(<v>)       =>  ( VALTYPE(<v>)=="D" )
#translate ISLOGICAL(<v>)    =>  ( VALTYPE(<v>)=="L" )
#translate ISNIL(<v>)        =>  ( (<v>)==NIL )
#translate ISNUMBER(<v>)     =>  ( VALTYPE(<v>)=="N" )
#translate ISMEMO(<v>)       =>  ( VALTYPE(<v>)=="M" )
#translate ISOBJECT(<v>)     =>  ( VALTYPE(<v>)=="O" )

**********************
#define SOFT_CRLF       chr(141)+chr(10)
#define CRLF			chr(13)+chr(10)

//----------------- Comparison blocks to be used with AComp()
#define AC_MAX	  {|x,y| x > y }			   // Element with maximum value
#define AC_MIN	  {|x,y| x < y }			   // Element with minimum value
#define AC_MAXLEN {|x,y| LEN( x ) > LEN( y ) } // Element with maximum length
#define AC_MINLEN {|x,y| LEN( x ) < LEN( y ) } // Element with minimum length

//------------ Convert numeric to string w/o leading spaces
#xtranslate NTRIM(<N>) ;
		   => ;
		   ( LTrim(STR(<N>)) )

//------- compile a character string to a code block
//------- often preferable to do this instead of macro expansion
//------- for LOCATE conditions et cetera
#xtranslate COMPILE(<string>) ;
			=> ;
			&( "{||" +<string>+ "}" )

//------- makes a character string to a code block
//------- used by MyEval()
#xtranslate MakeBlock(<string>) ;
			=> ;
			"{||" +<string>+ "}"


//---------- Implementing Default Parameters
#xcommand DEFAULT <p> TO <val> [,<pn> TO <valn>] ;
		  => ;
		  <p> = iif(<p> = NIL, <val>, <p>) ;
		  [;<pn> = iif(<pn> = NIL, <valn>, <pn>)]

//----- set variables to specific values if given condition satisfied
#xcommand DEFAULT <p> TO <val> IF <cond> [, <pn> TO <valn> IF <condn>] ;
		  => ;
		  <p> := iif(<cond>, <val>, <p>) ;
		  [; <pn> := iif(<condn>, <valn>, <pn>)]

